#!/usr/bin/perl

if ((scalar(@ARGV)<=2) ||
    (!($ARGV[2] =~ /^(get|index|name|query)$/i)) ||
    ((scalar(@ARGV)!=3) && ($ARGV[2] =~ /^index$/i)) ||
    ((scalar(@ARGV)!=3) && ($ARGV[2] =~ /^name$/i)) ||
    ((scalar(@ARGV)!=4) && ($ARGV[2] =~ /^query$/i)) ||
    ((scalar(@ARGV)!=5) && ($ARGV[2] =~ /^get$/i)) ||
    (($ARGV[2] =~ /^(get|query)$/i) && (!($ARGV[3] =~ /^nsVpnMon(VpnName|if(Speed|Bytes(In|Out)))$/))) ||
    (($ARGV[2] =~ /^(get)$/i) && (!($ARGV[4] =~ /^\d+$/)))
   ) {
  print STDERR "Usage:\n";
  print STDERR "$0 <HOSTNAME> <COMMUNITY> index\n";
  print STDERR "$0 <HOSTNAME> <COMMUNITY> name\n";
  print STDERR "$0 <HOSTNAME> <COMMUNITY> query <OID>\n";
  print STDERR "$0 <HOSTNAME> <COMMUNITY> get <OID> <index>\n";
  print STDERR "\n";
  print STDERR "The following OIDs are supported:\n";
  print STDERR "nsVpnMonVpnName\n";
  print STDERR "nsVpnMonifSpeed\n";
  print STDERR "nsVpnMonifBytesIn\n";
  print STDERR "nsVpnMonifBytesOut\n";
  exit 1;
}

$hostname=$ARGV[0];
$hostname=~ s/[^0-9a-zA-Z_.\/-]//g;
$snmpcommunity=$ARGV[1];
$cmd=$ARGV[2];
if ($cmd =~ /^(get|query)$/i) {
  $OID=$ARGV[3];
}
if ($cmd =~ /^get$/i) {
  $index=$ARGV[4];
}
%oids = (
        'index'         => '.1.3.6.1.4.1.3224.4.1.1.1.1',
        'nsVpnMonVpnName'       => '.1.3.6.1.4.1.3224.4.1.1.1.4',
        'ifSpeed'               => '.1.3.6.1.2.1.2.2.1.5',
        'nsVpnMonifSpeed'               => 'nsVpnMonifSpeed',
        'nsVpnMonifIndex'       => '.1.3.6.1.4.1.3224.4.1.1.1.39',
        'nsVpnMonifBytesIn'     => '.1.3.6.1.4.1.3224.4.1.1.1.35',
        'nsVpnMonifBytesOut'    => '.1.3.6.1.4.1.3224.4.1.1.1.36',
        );
$xml_delimiter = "!";
$snmp_ver = "2c";

sub snmpindex {
  return `snmpwalk -O vq '$hostname' -v $snmp_ver -c '$snmpcommunity' $oids{'index'}`;
}

sub snmpindexname {
  return `snmpwalk -O vq '$hostname' -v $snmp_ver -c '$snmpcommunity' $oids{'nsVpnMonVpnName'}`;
}

sub snmpget {
  my($oid) = $_[0];
  if ($oid =~ /nsVpnMonifSpeed/) {
  my($index);
    $index = $oid;
    $index =~ s/nsVpnMonifSpeed//;
    $oid = $oids{'ifSpeed'} . "." . snmpget("$oids{'nsVpnMonifIndex'}$index");
  }

  return `snmpget -O vq '$hostname' -v $snmp_ver -c '$snmpcommunity' $oid`;
}

if ($cmd =~ /^index$/i) {
  print snmpindex();
}

if ($cmd =~ /^name$/i) {
  print snmpindexname();
}

if ($cmd =~ /^query$/i) {
  @indexes = split(/\s+/,snmpindex());
  foreach $index (sort {$a <=> $b} @indexes) {
    $output=snmpget("$oids{$OID}.$index");
  print $index . $xml_delimiter . $output;
  }
}

if ($cmd =~ /^get$/i) {
  $output=snmpget("$oids{$OID}.$index");
  print $output;
}